Code

add: allow configurations to be overriden by command line
[git.git] / t / lib-git-svn.sh
1 . ./test-lib.sh
3 if test -n "$NO_SVN_TESTS"
4 then
5         test_expect_success 'skipping git-svn tests, NO_SVN_TESTS defined' :
6         test_done
7         exit
8 fi
10 GIT_DIR=$PWD/.git
11 GIT_SVN_DIR=$GIT_DIR/svn/git-svn
12 SVN_TREE=$GIT_SVN_DIR/svn-tree
14 svn >/dev/null 2>&1
15 if test $? -ne 1
16 then
17     test_expect_success 'skipping git-svn tests, svn not found' :
18     test_done
19     exit
20 fi
22 svnrepo=$PWD/svnrepo
23 export svnrepo
25 perl -w -e "
26 use SVN::Core;
27 use SVN::Repos;
28 \$SVN::Core::VERSION gt '1.1.0' or exit(42);
29 system(qw/svnadmin create --fs-type fsfs/, \$ENV{svnrepo}) == 0 or exit(41);
30 " >&3 2>&4
31 x=$?
32 if test $x -ne 0
33 then
34         if test $x -eq 42; then
35                 err='Perl SVN libraries must be >= 1.1.0'
36         elif test $x -eq 41; then
37                 err='svnadmin failed to create fsfs repository'
38         else
39                 err='Perl SVN libraries not found or unusable, skipping test'
40         fi
41         test_expect_success "$err" :
42         test_done
43         exit
44 fi
46 rawsvnrepo="$svnrepo"
47 svnrepo="file://$svnrepo"
49 poke() {
50         test-chmtime +1 "$1"
51 }
53 for d in \
54         "$SVN_HTTPD_PATH" \
55         /usr/sbin/apache2 \
56         /usr/sbin/httpd \
57 ; do
58         if test -f "$d"
59         then
60                 SVN_HTTPD_PATH="$d"
61                 break
62         fi
63 done
64 for d in \
65         "$SVN_HTTPD_MODULE_PATH" \
66         /usr/lib/apache2/modules \
67         /usr/libexec/apache2 \
68 ; do
69         if test -d "$d"
70         then
71                 SVN_HTTPD_MODULE_PATH="$d"
72                 break
73         fi
74 done
76 start_httpd () {
77         repo_base_path="$1"
78         if test -z "$SVN_HTTPD_PORT"
79         then
80                 echo >&2 'SVN_HTTPD_PORT is not defined!'
81                 return
82         fi
83         if test -z "$repo_base_path"
84         then
85                 repo_base_path=svn
86         fi
88         mkdir "$GIT_DIR"/logs
90         cat > "$GIT_DIR/httpd.conf" <<EOF
91 ServerName "git-svn test"
92 ServerRoot "$GIT_DIR"
93 DocumentRoot "$GIT_DIR"
94 PidFile "$GIT_DIR/httpd.pid"
95 LockFile logs/accept.lock
96 Listen 127.0.0.1:$SVN_HTTPD_PORT
97 LoadModule dav_module $SVN_HTTPD_MODULE_PATH/mod_dav.so
98 LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
99 <Location /$repo_base_path>
100         DAV svn
101         SVNPath "$rawsvnrepo"
102 </Location>
103 EOF
104         "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
105         svnrepo="http://127.0.0.1:$SVN_HTTPD_PORT/$repo_base_path"
108 stop_httpd () {
109         test -z "$SVN_HTTPD_PORT" && return
110         "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
113 convert_to_rev_db () {
114         perl -w -- - "$@" <<\EOF
115 use strict;
116 @ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
117 open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
118 open my $rd, '<', $ARGV[0] or die "$!: couldn't open: $ARGV[0]";
119 my $size = (stat($rd))[7];
120 ($size % 24) == 0 or die "Inconsistent size: $size";
121 while (sysread($rd, my $buf, 24) == 24) {
122         my ($r, $c) = unpack('NH40', $buf);
123         my $offset = $r * 41;
124         seek $wr, 0, 2 or die $!;
125         my $pos = tell $wr;
126         if ($pos < $offset) {
127                 for (1 .. (($offset - $pos) / 41)) {
128                         print $wr (('0' x 40),"\n") or die $!;
129                 }
130         }
131         seek $wr, $offset, 0 or die $!;
132         print $wr $c,"\n" or die $!;
134 close $wr or die $!;
135 close $rd or die $!;
136 EOF
139 require_svnserve () {
140     if test -z "$SVNSERVE_PORT"
141     then
142         say 'skipping svnserve test. (set $SVNSERVE_PORT to enable)'
143         test_done
144         exit
145     fi
148 start_svnserve () {
149     svnserve --listen-port $SVNSERVE_PORT \
150              --root "$rawsvnrepo" \
151              --listen-once \
152              --listen-host 127.0.0.1 &